<script lang="ts">
import Vue from 'vue';
import { IsMobileMixin } from '../../mixins';
import { getClient } from '~/plugins/contentful.js';
import { CONTENT_TYPES } from '../../common/content-types';

export default Vue.extend({
  name: 'ResourcesBrowser',
  mixins: [IsMobileMixin],
  props: {
    data: {
      type: Object,
      required: true,
    },
  },

  data() {
    return {
      topics: ['All topics'],
      resourceTypes: ['All resource types'],
      languages: ['All languages'],
      selectedResourceType: 'All resource types',
      selectedLanguage: 'All languages',
      selectedTopic: 'All topics',
      numberOfSelectedItems: 9,
      rowView: false,
      resources: [],
    };
  },
  async fetch() {
    const resourcesList = await getClient().getEntries({
      content_type: CONTENT_TYPES.CARD_GROUP,
      include: 10,
      'sys.id': '8PQNcg11tHgVAOPIghKhU',
    });

    const resourcesArray = resourcesList.items[0].fields.card.map((card) => {
      return {
        title: card.fields.title,
        url: card.fields.cardLink,
        type: card.fields.iconName,
        language: card.fields.subtitle,
        teaser: card.fields.description,
        topics: card.fields.list || [],
        solutions: card.fields.pills || [],
      };
    });

    this.resources = resourcesArray;
  },
  computed: {
    itemsToRender() {
      const filteredResources = this.resources.filter((item: any) => {
        let filtered = true;
        if (
          this.selectedResourceType !== '' &&
          this.selectedResourceType !== 'All resource types'
        ) {
          filtered = item.type === this.selectedResourceType;
        }
        if (filtered) {
          if (
            this.selectedLanguage !== '' &&
            this.selectedLanguage !== 'All languages'
          ) {
            filtered = item.language === this.selectedLanguage;
          }
        }
        if (filtered) {
          if (
            this.selectedTopic !== '' &&
            this.selectedTopic !== 'All topics'
          ) {
            filtered = item.topics.includes(this.selectedTopic);
          }
        }
        return filtered;
      });
      return filteredResources.slice(0, this.numberOfSelectedItems);
    },
  },
  watch: {
    selectedTopic(newTopic) {
      this.$router.push({ query: { topic: newTopic } });
    },
  },
  beforeMount() {
    if (localStorage.getItem('lang')) {
      const preferredLang = JSON.parse(localStorage.getItem('lang'));

      if (preferredLang.value === 'en-us') {
        this.selectedLanguage = 'English';
      } else if (preferredLang.value === 'ja-jp') {
        this.selectedLanguage = 'Japanese';
      } else if (preferredLang.value === 'es') {
        this.selectedLanguage = 'Spanish';
      }
    }
  },
  mounted() {
    if (this.isMobile) {
      this.numberOfSelectedItems = 3;
    }

    if (this.$route?.query?.topic) {
      this.selectedTopic = this.$route?.query?.topic;
    }

    const topics: string[] = [];
    const languages: string[] = [];
    const types: string[] = [];

    this.resources.forEach((resource) => {
      resource.topics.map((topic) => topics.push(topic));
      languages.push(resource.language);
      types.push(resource.type);
    });

    this.languages = [...this.languages, ...new Set(languages)];
    this.resourceTypes = [...this.resourceTypes, ...new Set(types)].sort();
    this.topics = [...this.topics, ...new Set(topics)].sort();
  },
  methods: {
    loadMoreResources() {
      this.numberOfSelectedItems += 9;
    },
    iconToRender(resourceType: string) {
      if (resourceType === 'Report') {
        return 'slp-report';
      }
      if (resourceType === 'eBook') {
        return 'slp-ebook';
      }
      return 'slp-web';
    },
    toggleRowView(state: boolean) {
      if (this.isMobile) {
        this.rowView = false;
      }
      this.rowView = state;
    },
  },
});
</script>

<template>
  <SlpContainer
    v-if="resources.length > 0"
    id="resources-browser"
    variant="light-purple-100"
    class="slp-pt-24"
  >
    <SlpRow class="title-row">
      <SlpColumn>
        <SlpTypography tag="h2" variant="heading2-bold"
          >{{ data.title }}
        </SlpTypography>
      </SlpColumn>
    </SlpRow>
    <SlpRow class="slp-mb-8">
      <SlpColumn>
        <SlpTypography tag="p" variant="body2-bold">
          {{ data.filter_text }}
        </SlpTypography></SlpColumn
      >
    </SlpRow>

    <SlpRow :key="selectedTopic" class="dropdowns">
      <SlpColumn :cols="3" class="dropdown-container">
        <SlpDropdown
          v-model="selectedTopic"
          name="topics"
          :options="topics"
        ></SlpDropdown>
      </SlpColumn>
      <SlpColumn :cols="3" class="dropdown-container">
        <SlpDropdown
          v-model="selectedResourceType"
          name="resourceType"
          :options="resourceTypes"
        ></SlpDropdown>
      </SlpColumn>
      <SlpColumn :cols="3" class="dropdown-container">
        <SlpDropdown
          v-model="selectedLanguage"
          name="language"
          :options="languages"
        ></SlpDropdown>
      </SlpColumn>
      <SlpColumn v-if="!isMobile" :cols="1">
        <div class="btn-layout-container">
          <div
            class="btn-layout"
            :class="{ 'btn-layout--active': !rowView }"
            @click="toggleRowView(false)"
          >
            <SlpIcon name="applications" variant="product" />
          </div>
          <div
            class="btn-layout"
            :class="{ 'btn-layout--active': rowView }"
            @click="toggleRowView(true)"
          >
            <SlpIcon name="list-bulleted" variant="product" />
          </div>
        </div>
      </SlpColumn>
    </SlpRow>
    <SlpRow
      v-if="itemsToRender.length === 0"
      class="slp-justify-content-center"
    >
      <SlpColumn :cols="12">
        <SlpTypography tag="p" variant="body1-bold">
          {{ data.empty_resource_msg }}
        </SlpTypography>
      </SlpColumn>
    </SlpRow>
    <SlpRow v-else class="slp-justify-content-start">
      <SlpColumn
        v-for="resource in itemsToRender"
        :key="resource.title"
        :cols="isMobile ? 12 : 4"
        class="card-container"
        :class="{ 'card-container__row-view': rowView }"
      >
        <SlpCard100
          class="card"
          :class="{ 'card__row-view': rowView }"
          :link="resource.url"
          :resource-type="resource.type"
          :data-resource-type="resource.type"
          :data-resource-language="resource.language"
          :data-resource-solutions="
            resource.solutions.map((solution) => `||${solution}`)
          "
          :data-resource-topics="resource.topics.map((topic) => `||${topic}`)"
          :icon="iconToRender(resource.type)"
        >
          <div class="card--topic">
            <SlpTypography tag="p" variant="body2">{{
              resource.topics[0]
            }}</SlpTypography>
          </div>
          <div class="card--title">
            <SlpTypography tag="h5" variant="heading5-bold">
              {{ resource.title }}
            </SlpTypography>
          </div>
          <div class="card--description">
            <SlpTypography tag="p" variant="body1">
              {{ resource.teaser }}
            </SlpTypography>
          </div>
          <div
            class="slp-card100__slot--cta card--cta"
            :class="{ 'card--cta__row-view': rowView }"
          >
            <span>{{ data.learn_more_text }}</span
            ><SlpIcon variant="product" name="chevron-lg-right" />
          </div>
        </SlpCard100>
      </SlpColumn>
    </SlpRow>
    <SlpRow class="slp-mb-96 slp-justify-content-center">
      <SlpColumn :cols="12">
        <SlpButton
          v-if="numberOfSelectedItems <= itemsToRender.length"
          variant="primary"
          class="slp-mt-64 slp-mb-24"
          @click.native="loadMoreResources"
          >{{ data.load_more_text }}</SlpButton
        >
      </SlpColumn>
    </SlpRow>
  </SlpContainer>
</template>

<style scoped lang="scss">
.title-row {
  margin: $spacing-96 0 $spacing-64 0;

  @media (max-width: $breakpoint-md) {
    margin: $spacing-32 0;
  }
}
.dropdowns {
  display: flex;
  justify-content: space-between;
  align-items: center;
  margin-bottom: $spacing-48;

  @media (max-width: $breakpoint-lg) {
    align-items: flex-start;
    flex-direction: column;
  }

  .dropdown-container {
    & > .dropdown {
      min-width: 306px;
    }

    @media (max-width: $breakpoint-lg) {
      min-width: 100%;
      margin-bottom: $spacing-16;
    }
  }
}
.card-container {
  @media (max-width: $breakpoint-lg) {
    min-width: 100%;
  }

  &__row-view {
    min-width: 100%;
  }

  .card {
    background-color: white;
    position: relative;
    min-height: 484px;
    min-width: 354px;
    margin-bottom: $spacing-24;
    border-radius: 4px;

    @media (max-width: $breakpoint-lg) {
      min-width: 100%;
      min-height: fit-content;
    }

    &:hover {
      background-color: white;
    }

    &__row-view {
      min-width: 100%;
      min-height: 212px;

      & > * {
        max-width: 900px;
      }

      .card {
        &--title {
          height: fit-content;
        }
      }
    }

    &--topic {
      padding-bottom: $spacing-8 !important;
    }

    &--title {
      padding-bottom: $spacing-8 !important;

      h5 {
        overflow: hidden;
        text-overflow: ellipsis;

        @media (max-width: $breakpoint-lg) {
          height: fit-content;
        }
      }
    }

    &--description {
      p {
        overflow: hidden;
        text-overflow: ellipsis;
      }

      @media (max-width: $breakpoint-lg) {
        margin-bottom: $spacing-32;
        padding-bottom: 0;
      }
    }

    &--cta {
      position: absolute;
      margin-bottom: $spacing-32;
      padding-left: 0;
      bottom: 0;

      &__row-view {
        right: $spacing-24;
        bottom: 30%;
      }
    }
  }
}

.btn-layout-container {
  display: flex;
  border: 1px solid $color-text-link-100;
  border-radius: 20px;
  width: 100%;
  margin-left: -$spacing-24;

  @media (max-width: $breakpoint-lg) {
    display: none;
  }

  .btn-layout {
    display: flex;
    justify-content: center;
    width: 100%;
    padding: $spacing-8;
    border-radius: 20px;
    cursor: pointer;

    &:hover {
      background-color: $color-surface-900;
    }
    &--active {
      background-color: $color-surface-900;
    }

    & > .slp-icon {
      margin-bottom: 4px !important;
    }
  }
}

.dropdown {
  background-color: white;
}
</style>
